exec("./fastprojectiles/support_staticHitscan.cs");
exec("./datablocks.cs");
exec("./HMG_M2.cs");

if($Pref::RHMG_Heating $= "")			{$Pref::RHMG_Heating 		= true;}
if($Pref::RHMG_Ammo $= "")				{$Pref::RHMG_Ammo 			= true;}
if($Pref::RHMG_Jamming $= "")			{$Pref::RHMG_Jamming 		= true;}
if($Pref::RHMG_SitStand $= "")			{$Pref::RHMG_SitStand 		= true;}
if($Pref::RHMG_FastProjectile $= "")	{$Pref::RHMG_FastProjectile = true;}

function Player::RHMG_setTrigger(%obj, %val)
{
	switch(%obj.RHMGType)
	{
		case 0:
			%obj.RHMG_M2SetTrigger(%val);
		default:
			return;
	}
}

function Player::RHMG_toggleSitting(%player, %turret)
{
	if(!$Pref::RHMG_SitStand)
		return;

	if(%player.RHMG_sitting)
	{
		%turret.playThread(0, Manip);
		%player.playThread(0, root);
		%player.playThread(1, root);
		%player.RHMG_sitting = false;
		%turret.playThread(1, standPos);
		
	}
	else
	{
		%turret.playThread(0, Manipsmall);
		%player.playThread(0, sit);
		%player.playThread(1, armReadyBoth);
		%player.RHMG_sitting = true;
		%turret.playThread(1, root);
	}
}

package RallyHMGPack
{
	function Armor::onTrigger(%this, %player, %slot, %val)
	{
		Parent::onTrigger(%this, %player, %slot, %val);
		
		if(!%slot && isObject(%turret = %player.getObjectMount()) && %turret.getDatablock().isRHMG)
		{
			%turret.RHMG_setTrigger(%val);
		}
	}
	
	function serverCmdActivateStuff(%client)
	{
		Parent::serverCmdActivateStuff(%client);
		
		if(!$Pref::RHMG_SitStand)
			return;
		
		%player = %client.player;
		if(isObject(%turret = %player.getObjectMount()) && %turret.getDatablock().isRHMG)
		{
			%player.RHMG_toggleSitting(%turret);
		}
	}
	
	function serverCmdLight(%client)
	{
		if(!$Pref::RHMG_Ammo)
			return Parent::serverCmdLight(%client);
	
		%player = %client.player;
		if(isObject(%turret = %player.getObjectMount()) && %turret.getDatablock().isRHMG && %turret.ammo < 200 && !%turret.RHMG_ReloadStage)
		{
			%turret.RHMG_M2_StartReload();
		}
		else
		{
			Parent::serverCmdLight(%client);
		}
	}
	
	function Armor::onMount(%this, %obj, %mount, %node)
	{
		if(isObject(%mount))
		{
			if(%mount.getDatablock().isRHMG)
			{
				%obj.RHMG_sitting = true;
				%obj.playThread(1, armReadyBoth);
				commandToClient(%obj.client, 'SetPaintingDisabled', true);
			}
		}
		Parent::onMount(%this, %obj, %mount, %node);
	}
	
	function Armor::onUnMount(%this, %obj, %mount, %node)
	{
		if(isObject(%mount))
		{
			if(%mount.getDatablock().isRHMG)
			{
				%obj.playThread(1, root);
				
				if(%obj.client.minigame.enablePainting || !isObject(%obj.client.minigame))
					commandToClient(%obj.client, 'SetPaintingDisabled', false);
			}
		}
		Parent::onUnMount(%this, %obj, %mount, %node);
	}
	
};
activatePackage(RallyHMGPack);